<template>
  <div>
    <ApiPicker />

    <h2>Payment & Call</h2>

    <column v-if="walletAddress">
      <cell>
        Linked with {{walletAddress}}
      </cell>
      <cell>
        <select v-model="type">
          <option value="call_request">Call Request</option>
          <option value="payment_request">Payment Request</option>
        </select>
      </cell>

      <cell>
        <label>Scope</label>
        <input v-model="scope" />
      </cell>

      <cell>
        <label>Status</label>
        <input v-model="network" />
      </cell>

      <cell>
        <label>Address</label>
        <input v-model="address" />
      </cell>

      <cell>
        <label>Amount</label>
        <input v-model="amount" />
      </cell>

      <cell>
        <label>Memo</label>
        <input v-model="memo" />
      </cell>


      <cell v-if="type=='call_request'">
        <label>ABI</label>
        <input v-model="abi" />
      </cell>

      <cell>
        <label>Transaction Size</label>
        <input v-model="transactionSize" />
      </cell>

      
      <cell>
        <label>Transaction Fee</label>
        <input v-model="transactionFee" />
      </cell>

      <h4>Push Notification</h4>
      <cell>
        <input type="checkbox" v-model="sendPN">Send Push Notification</input>
      </cell>
      <cell>
        <label>Title</label>
        <input v-model="pushNotification.title" />
      </cell>
      <cell>
        <label>Message</label>
        <input v-model="pushNotification.message" />
      </cell>
      <cell>
        <label>Action</label>
        <input v-model="pushNotification.action" />
      </cell>

      
      <stateful-button v-if="type=='call_request'" :click="callRequest">Call Request</stateful-button>
      <stateful-button v-else-if="type=='payment_request'" :click="paymentRequest">Payment Request</stateful-button>

    </column>
    <column v-else>
      <cell>
        Link with this:
        <QrCode v-if="qrUrl" :value="qrUrl"/>
      </cell>

    </column>


    <p>{{ result }}</p>

    <button @click="reset">RESET</button>
  </div>
</template>
<script>

export default {
  data() {
    return {
      type: 'payment_request',
      result: null,
      walletAddress: null,
      qrUrl: null,
      
      scope: 'eth',
      network: 'mainnet',
      address: '0xfB6916095ca1df60bB79Ce92cE3Ea74c37c5d359',
      amount: '0.01',
      abi: '',
      memo: 'Donate to ETH Tip Jar',
      transactionSize: '',
      transactionFee: '',

      sendPN: true,
      
      pushNotification: {
        title: 'Approve ETH Tip',
        message: 'Approve ETH Tip',
        action: '',
      }
    };
  },
  async mounted() {
    await this.$brd.ready()
    this.qrUrl = this.$brd.eme.qrLinkUrl();

    await this.$brd.link();
    this.walletAddress = await this.$brd.requestAddress();
  },
  computed: {
    options() {
      var o = { 
        transactionSize: this.transactionSize,
        transactionFee: this.transactionFee,
        memo: this.memo,
        network: this.network,
      };

      if(this.sendPN) {
        o.pushNotification = this.pushNotification;
      }

      return o;
    }
  },
  methods: {
    
    async callRequest() {
      this.result = await this.$brd.callRequest(
        this.scope,
        this.address,
        (this.amount * 1E18).toFixed(0),
        this.abi,
        this.options,
      );
    },
    async paymentRequest() {
      this.result = await this.$brd.paymentRequest(
        this.scope,
        this.address,
        (this.amount * 1E18).toFixed(0),
        this.options
      );
      
    },

    async reset() {
      await this.$brd.destroy();
      document.location.reload();
    }

  }
}
  
</script>
